# sb::Plugin::BeStrict
# == written by T.Otani <takuya.otani@gmail.com> ===
# == Copyright (C) 2004 SimpleBoxes/SerendipityNZ ==

use strict;

# ======================================
package sb::Plugin::BeStrict;
sb::Plugin->register_plugin(
	'lang' => {
		'ja' => 'euc',
		'en' => 'ascii',
	},
	'text' => {
		'type'    => 'cms',
		'name'    => 'Be Strict',
		'text'    => 'be strict as much as possible',
		'author'  => 'takkyun',
		'detail'  => 'http://serenebach.net/',
		'version' => '0.02',
		# 0.02 [2007/04/30] fixed a bug which sequel cannot be displayed
		# 0.01 [2007/04/25] added _sequel
		# 0.00 [2007/04/09] generated
	},
	'file' => undef,
	'data' => undef,
);
sb::Plugin->register_content_module(
	'type'     => 'entry',
	'callback' => \&sb::Plugin::BeStrict::_body_text,
	'name'     => 'bestrict_body_text',
	'field'    => 'body_text',
);
sb::Plugin->register_content_module(
	'type'     => 'entry',
	'callback' => \&sb::Plugin::BeStrict::_sequel,
	'name'     => 'bestrict_sequel',
	'field'    => 'sequel',
);
# ======================================
use sb::Config ();
sb::Config->get->value('basic_marking'=>0); # force to set basic marking off
# ======================================
use sb::Content ();
sub _body_text
{
	my $cms   = shift;
	my $entry = shift;
	my %var   = @_;
	if ($entry->body ne '')
	{
		my $body = $entry->formated_body;
		$cms->tag('entry_description'=>$body);
	}
	if ($entry->more ne '')
	{
		my $permalink = &sb::Content::Entry::_permalink($entry,$var{'cat'},'more',$var{'mode'});
		my $more = ($var{'mode'} eq 'ent') 
		         ? $entry->formated_more 
		         : '<a href="' . $permalink . '">' . $var{'lang'}->string('parts_sequel') . '</a>';
		$more = ($var{'mode'} eq 'ent') 
		         ? '<div class="entry_more" id="sequel">' . $more . '</div>'
		         : '<p class="entry_more">' . $more . '</p>';
		$cms->tag('entry_sequel'=>$more);
	}
	$cms->tag('entry_excerpt'=>$entry->sum);
}
sub _sequel
{
	my $cms   = shift;
	my $entry = shift;
	my %var   = @_;
	return if (!$cms->existed('sequel'));
	if ($var{'mode'} eq 'ent' or $var{'mode'} eq 'mob')
	{
		foreach my $label ('next','prev')
		{
			$cms->block('sequel_' . $label => ($var{'entryinfo'}{'neighbor'}{$label}) ? 1 : 0);
		}
	}
	else
	{
		$cms->deleteBlock('sequel_prev');
		$cms->deleteBlock('sequel_next');
	}
	return &sb::Content::Entry::_sequel($cms,$entry,%var);
}
1;
__END__
